<template>
  <v-col md="8" cols="12">
    <v-card>
      <v-card-title>
        Projects
      </v-card-title>
      <v-card-text>
        <v-row>
          <v-col md="3" cols="6" v-for="project in projects" :key="project.id">
            <v-hover v-slot:default="{ hover }">
              <v-img :src="project.image.url"
                     height="150px"
                     :style="'background-color: '+project.image.background_color_hex"
                     contain
                     class="rounded"
              >
                <v-fade-transition>
                  <v-overlay :value="hover"
                             absolute
                             class="cursor--link hidden-sm-and-down">
                    <h3>{{project.name}}</h3>
                    <br>
                    <v-btn v-if="project.more_info.ext_action" :click="project.more_info.action('3d-printing')">View info</v-btn>
                    <v-btn v-if="!project.more_info.ext_action" @click="show_project_overlay = projects.indexOf(project)">View info</v-btn>
                  </v-overlay>
                </v-fade-transition>
              </v-img>
            </v-hover>
            <div class="more-info-mobile hidden-md-and-up">
              <br>
              <h3>{{project.name}}</h3>
              <br>
              <v-btn v-if="project.more_info.ext_action" :click="project.more_info.action('3d-printing')">View info</v-btn>
              <v-btn v-if="!project.more_info.ext_action" @click="show_project_overlay = projects.indexOf(project)">View info</v-btn>
              <br>
              <br>
            </div>
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
    <v-fade-transition>
      <v-overlay :value="show_project_overlay !== undefined"
                 @click="show_project_overlay = undefined"
                 opacity="0.8">
        <v-window continuous show-arrows
                  :style="'width:'+overlayCardWidth+';'"
                  v-bind:value="show_project_overlay">
          <v-window-item v-for="project in projects"
                         :key="project.name"
                         :v-slot:default="show_project_overlay">
            <v-card :width="overlayCardWidth">
              <v-img :src="project.image.url"
                     contain
                     center
                     height="290px"
                     :style="'background-color: '+project.image.background_color_hex"/>
              <v-card-title>
                {{project.name}}
              </v-card-title>
              <v-card-text>
                {{project.description}}
              </v-card-text>
            </v-card>
          </v-window-item>
        </v-window>
      </v-overlay>
    </v-fade-transition>
  </v-col>
</template>

<script>
import {scrollToRef} from "@/helpers/scroll";

export default {
  name: "Projects",
  computed: {
    overlayCardWidth () {
      switch (this.$vuetify.breakpoint.name) {
        case 'xs': return '99vw'
        case 'sm': return '80vw'
        case 'md': return '60vw'
        case 'lg': return '40vw'
        case 'xl': return '40vw'
      }
      return '100%'
    },
  },
  data: () => ({
    show_project_overlay: undefined,
    projects: [
      {
        id: "homelab",
        name: "Homelab",
        image: {
          action: "https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Ftse4.mm.bing.net%2Fth%3Fid%3DOIP.5Q63FcIo173XTvkE1rCVdgHaE7%26pid%3DApi&f=1",
          background_color_hex: "#fff"
        },
        description: "My Unifi and DIY homelab: the project I probably spent the most time (and money...) on. It's " +
            "great for making small it projects and experimenting around with tech and software. " +
            "Money and time well spent!",
        more_info: {
          ext_action: false,
          action: undefined
        },
        show_overlay: false
      },
      {
        id: 'ha',
        name: "Home Assistant",
        image: {
          action: "https://cdn.sgart.dev/assets/own/homeassistant-logo.png",
          background_color_hex: "#41bdf5"
        },
        description: "Home Assistant is a simple smart home solution I use to connect my smart devices. This way I'm " +
            "not required to use the apps of each brand and it assures a better privacy. Take that Zuck!",
        more_info: {
          ext_action: false,
          action: undefined
        },
        show_overlay: false
      },
      {
        id: "pihole",
        name: "Pi-Hole",
        image: {
          action: "https://cdn.sgart.dev/assets/own/pihole-logo.png",
          background_color_hex: "#f66"
        },
        description: "The black hole for all the nasty adverts, trackers and all the other stuff in my internet " +
            "traffic. Works great for playing shitty mobile games without distracting ads and gets rid of a lot of " +
            "trackers, as well as ads in all digital newspapers. I still need an advanced ad and tracker blocker on my " +
            "devices for more persintent ads, as Pi-Hole is just for dns resolution.",
        more_info: {
          ext_action: false,
          action: undefined
        },
        show_overlay: false
      },
      {
        id: "prusamk3splus",
        name: "Prusa MK3S+",
        image: {
          action: "https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Ftse4.mm.bing.net%2Fth%3Fid%3DOIP.65hIYlpo0vGQ0fNIQ_mr3wHaFj%26pid%3DApi&f=1",
          background_color_hex: "#fff"
        },
        description: "My 3d printer I bought a while ago. Works great and is really useful in case I need something " +
            "simple without wanting to pay a fortune for it. I sometimes print stuff for other people, so if you're " +
            "interested, click me. To see some prints I've made so far, scroll down a bit to the next section.",
        more_info: {
          ext_action: true,
          action: scrollToRef
        },
        show_overlay: false
      },
      {
        id: "djimini2",
        name: "DJI Mini 2",
        image: {
          action: "https://external-content.duckduckgo.com/iu/?u=https%3A%2F%2Ftse1.mm.bing.net%2Fth%3Fid%3DOIP.PXxWJplK9ObsWdxdFCqLOwHaE8%26pid%3DApi&f=1",
          background_color_hex: "#fff"
        },
        description: "Due to swiss laws, flying with a drone lighter than 500g is allowed pretty much everywhere " +
            "with almost no restriction, which makes the DJI Mini 2 (249g) a pretty good drone to fly near cities " +
            "and other public places. It still has a 4K (30FPS) camera for good quality pictures.",
        more_info: {
          ext_action: false,
          action: undefined
        },
        show_overlay: false
      }
    ]
  })
}
</script>

<style>
.cursor--link {
  cursor: pointer;
}
</style>
